﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
Sub Class_Globals
	Public bw As X2BodyWrapper
	Private x2 As X2Utils 'ignore
	Dim impulsValue As Float = 2.
	Dim fallMultiplier As Float = 2.5
	Dim highJumpMultiplier As Float = 2.5
End Sub

Public Sub Initialize (wrapper As X2BodyWrapper)
	bw = wrapper
	x2 = bw.X2
End Sub

Public Sub Tick (GS As X2GameStep)
	
	' push the ball if pressed	
	If x2.mGame.Jump = True Then
		x2.mGame.Jump = False 
		bw.Body.ApplyLinearImpulse(x2.CreateVec2(0, impulsValue), bw.Body.Position)
		x2.SoundPool.PlaySound("wing")
	End If
		

	'
	' ******************************************************************
	' *  Modify the BodyGravity for nicer Jumps                        *
	' *                                                                *
	' *  1) jump upwards and downwards have different Gravity settings *
	' *  2) shot press done with normal Gravity = normal jumps         *
	' *  3) long press done Gravity will be lower = higher jumps       *
	' *                                                                *
	' ******************************************************************
	' 
	' Gravity normal = normal jump hight
 	bw.mWorld.Gravity.Set(0,-10)
	'
	If bw.Body.LinearVelocity.Y < 0 Then ' are in up- or down direction?
		' body is in falling direction = raise of Gravity
		bw.mWorld.Gravity.Set(0 , bw.mWorld.Gravity.Y * fallMultiplier)
		'
	Else if bw.Body.LinearVelocity.Y > 0 And (x2.mGame.Up = False) Then ' in up-direction and long pressing
		' Gravity lower = higher Jump
		bw.mWorld.Gravity.Set(0 , bw.mWorld.Gravity.Y / highJumpMultiplier )
	Else 
		' non of all = normal Gravity remains (this if-part can be removed)
	End If
	'
	bw.Body.LinearVelocity = x2.CreateVec2(0, Min(4, bw.Body.LinearVelocity.Y))
	'
	If GS.ShouldDraw Then
		bw.UpdateGraphic(GS, True)
	End If
	
End Sub