﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World
	Public Ground As X2BodyWrapper
	Private ivForeground As B4XView
	Public ivBackground As B4XView
	Public lblStats As B4XView
	Private Ground As X2BodyWrapper

	Public GroundLevel As Float
	
	Public mBall As Ball

	Public lblScore As B4XView

	Private Panel1 As B4XView 'ignore
	Public  Jump, Up As Boolean

End Sub


Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("GameLayout")
	world.Initialize("world", world.CreateVec2(0, -10))
	X2.Initialize(Me, ivForeground, world)
	'Configure the dimensions. Center point is (0, 3) and the visible width is 6 meters.
	X2.ConfigureDimensions(world.CreateVec2(0, 3), 9)
	
	'Load the graphics and add them to the cache.
	
	'comment to disable debug drawing
	'X2.EnableDebugDraw
	LoadBallGraphics
	X2.SoundPool.AddSound("wing", File.DirAssets, "wing.mp3")
	
'	X2.SlowDownPhysicsScale = 5
'	X2.UpdateTimeParameters
End Sub

Private Sub LoadBallGraphics
	'Load the ball graphics and add them to the cache.

	Dim sb As X2ScaledBitmap = X2.LoadBmp(File.DirAssets, "ball-1.png", 1.5, 1.5 , True)
	X2.GraphicCache.PutGraphic("ball", Array(sb))

End Sub

Public Sub StartGame
	If X2.IsRunning Then Return

	Jump = False
	Up = False
	
	X2.Reset
	X2.UpdateWorldCenter(X2.CreateVec2(0, 3))
	CreateGround

	X2.Start
	X2.AddFutureTask(Me, "Create_Ball", 500, Null)

End Sub

Public Sub Stop
	X2.Stop
End Sub


Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	
End Sub

Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub

Public Sub Tick (GS As X2GameStep)

End Sub


Private Sub Create_Ball(ft As X2FutureTask)
	Dim bd As B2BodyDef
	bd.BodyType = bd.TYPE_DYNAMIC
	bd.Position = X2.CreateVec2(X2.ShapeAABB.Width /2 , 4)
	bd.LinearVelocity = X2.CreateVec2(0, 0)
	Dim wrapper As X2BodyWrapper = X2.CreateBodyAndWrapper(bd, mBall, "ball")
	wrapper.GraphicName = "ball"
	mBall.Initialize(wrapper)
	
	Dim size As B2Vec2 = X2.GraphicCache.GetGraphicSizeMeters(wrapper.GraphicName, 0)
	Dim circle As B2CircleShape
	circle.Initialize(size.Y / 2)
	wrapper.Body.CreateFixture2(circle, 0.2)
End Sub


Private Sub CreateGround
	Dim GroundBox As B2Vec2 = X2.CreateVec2(9.6, 0.96)
	Dim sb As X2ScaledBitmap = X2.LoadBmp(File.DirAssets, "ground.png", GroundBox.X, GroundBox.Y, False)
	X2.GraphicCache.PutGraphic("Ground", Array(sb))
	Dim bd As B2BodyDef
	bd.BodyType = bd.TYPE_STATIC 'the engine should not move it
	bd.Position = X2.CreateVec2(X2.ScreenAABB.Center.X, X2.ScreenAABB.BottomLeft.Y + GroundBox.Y / 2)
	Ground = X2.CreateBodyAndWrapper(bd, Null, "Ground")
	Ground.GraphicName = "ground"
	Dim rect As B2PolygonShape
	rect.Initialize
	rect.SetAsBox(GroundBox.X / 2, GroundBox.Y / 2)
	Ground.Body.CreateFixture2(rect, 1)
	GroundLevel = X2.ScreenAABB.BottomLeft.Y + GroundBox.Y
	Dim edge As B2EdgeShape
	edge.Initialize(X2.CreateVec2(-20, X2.ScreenAABB.TopRight.Y - bd.Position.Y - 0.01), _
		X2.CreateVec2(20, X2.ScreenAABB.TopRight.Y - bd.Position.Y - 0.01))
	Ground.Body.CreateFixture2(edge, 1)
End Sub

Private Sub World_BeginContact (Contact As B2Contact)

End Sub



#if B4A or B4i
Sub Panel1_Touch (Action As Int, X As Float, Y As Float)
	If Action = Panel1.TOUCH_ACTION_DOWN Then
		Jump = True
		Up = False
	else If Action = Panel1.TOUCH_ACTION_UP Then
		Jump = False
		Up = True
	Else If Action = Panel1.TOUCH_ACTION_MOVE_NOTOUCH Then
		Up = False
	End If
End Sub
#end if